// g++ -Wall -Wpedantic -std=c++17 -march=haswell stack-ds.cpp

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdexcept>

#define SIZE 100
#define TYPE int64_t

class stack {
private:
	TYPE content[SIZE];
	std::size_t top;
	
public:
	stack() {
		this->top = 0;
	}
	void push(TYPE x) {
        if ( this->top == SIZE-1 ) {
            throw std::out_of_range("stack full");
        }
		this->content[this->top] = x;
		this->top++;
	}
	TYPE pop() {
        if ( this->top == 0 ) {
            throw std::out_of_range("stack empty");
        }
		this->top--;
		return this->content[this->top];
	}
};

int main() {
    stack s = stack();
	s.push(12);
	s.push(13);
	s.push(14);
	printf("%ld\n", s.pop()); // prints 14
	printf("%ld\n", s.pop()); // prints 13
	s.push(15);
	printf("%ld\n", s.pop()); // prints 15
	printf("%ld\n", s.pop()); // prints 12
	//printf("%ld\n", s.pop()); // exception
	
	return 0;
}
